"use client"
import { useIntl } from "react-intl"

import { formatPrice } from "@/utils/numberFormatting"

import BoldRow from "../Bold"
import RegularRow from "../Regular"
import BedTypeRow from "./BedType"
import PackagesRow from "./Packages"

import { CurrencyEnum } from "@/types/enums/currency"
import type { SharedPriceRowProps } from "./price"

export interface VoucherPriceType {
  voucher?: {
    numberOfVouchers: number
  }
}

interface VoucherPriceProps extends SharedPriceRowProps {
  currency: string
  nights: number
  price: VoucherPriceType["voucher"]
}

export default function VoucherPrice({
  bedType,
  currency,
  nights,
  packages,
  price,
}: VoucherPriceProps) {
  const intl = useIntl()

  if (!price) {
    return null
  }

  const averagePriceTitle = intl.formatMessage({
    defaultMessage: "Average price per night",
  })

  const averagePricePerNight = `${price.numberOfVouchers / nights} ${CurrencyEnum.Voucher}`

  return (
    <>
      <BoldRow
        label={intl.formatMessage({ defaultMessage: "Room charge" })}
        value={formatPrice(intl, price.numberOfVouchers, CurrencyEnum.Voucher)}
      />
      {nights > 1 ? (
        <RegularRow label={averagePriceTitle} value={averagePricePerNight} />
      ) : null}
      <BedTypeRow bedType={bedType} currency={currency} />
      <PackagesRow packages={packages} />
    </>
  )
}
